"""
    Firefly III API Client

    This is the Python client for Firefly III API  # noqa: E501

    The version of the OpenAPI document: 1.5.6
    Contact: james@firefly-iii.org
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from firefly_iii_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from firefly_iii_client.exceptions import ApiAttributeError


def lazy_import():
    from firefly_iii_client.model.bill_paid_dates import BillPaidDates
    from firefly_iii_client.model.bill_repeat_frequency import BillRepeatFrequency
    globals()['BillPaidDates'] = BillPaidDates
    globals()['BillRepeatFrequency'] = BillRepeatFrequency


class Bill(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'amount_max': (str,),  # noqa: E501
            'amount_min': (str,),  # noqa: E501
            'date': (datetime,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'repeat_freq': (BillRepeatFrequency,),  # noqa: E501
            'active': (bool,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'currency_code': (str,),  # noqa: E501
            'currency_decimal_places': (int,),  # noqa: E501
            'currency_id': (str,),  # noqa: E501
            'currency_symbol': (str,),  # noqa: E501
            'end_date': (datetime,),  # noqa: E501
            'extension_date': (datetime,),  # noqa: E501
            'next_expected_match': (datetime, none_type,),  # noqa: E501
            'next_expected_match_diff': (str, none_type,),  # noqa: E501
            'notes': (str, none_type,),  # noqa: E501
            'object_group_id': (str, none_type,),  # noqa: E501
            'object_group_order': (int, none_type,),  # noqa: E501
            'object_group_title': (str, none_type,),  # noqa: E501
            'order': (int,),  # noqa: E501
            'paid_dates': ([BillPaidDates],),  # noqa: E501
            'pay_dates': ([datetime],),  # noqa: E501
            'skip': (int,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'amount_max': 'amount_max',  # noqa: E501
        'amount_min': 'amount_min',  # noqa: E501
        'date': 'date',  # noqa: E501
        'name': 'name',  # noqa: E501
        'repeat_freq': 'repeat_freq',  # noqa: E501
        'active': 'active',  # noqa: E501
        'created_at': 'created_at',  # noqa: E501
        'currency_code': 'currency_code',  # noqa: E501
        'currency_decimal_places': 'currency_decimal_places',  # noqa: E501
        'currency_id': 'currency_id',  # noqa: E501
        'currency_symbol': 'currency_symbol',  # noqa: E501
        'end_date': 'end_date',  # noqa: E501
        'extension_date': 'extension_date',  # noqa: E501
        'next_expected_match': 'next_expected_match',  # noqa: E501
        'next_expected_match_diff': 'next_expected_match_diff',  # noqa: E501
        'notes': 'notes',  # noqa: E501
        'object_group_id': 'object_group_id',  # noqa: E501
        'object_group_order': 'object_group_order',  # noqa: E501
        'object_group_title': 'object_group_title',  # noqa: E501
        'order': 'order',  # noqa: E501
        'paid_dates': 'paid_dates',  # noqa: E501
        'pay_dates': 'pay_dates',  # noqa: E501
        'skip': 'skip',  # noqa: E501
        'updated_at': 'updated_at',  # noqa: E501
    }

    read_only_vars = {
        'created_at',  # noqa: E501
        'currency_decimal_places',  # noqa: E501
        'currency_symbol',  # noqa: E501
        'next_expected_match',  # noqa: E501
        'next_expected_match_diff',  # noqa: E501
        'object_group_order',  # noqa: E501
        'paid_dates',  # noqa: E501
        'pay_dates',  # noqa: E501
        'updated_at',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, amount_max, amount_min, date, name, repeat_freq, *args, **kwargs):  # noqa: E501
        """Bill - a model defined in OpenAPI

        Args:
            amount_max (str):
            amount_min (str):
            date (datetime):
            name (str):
            repeat_freq (BillRepeatFrequency):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            active (bool): If the bill is active.. [optional]  # noqa: E501
            created_at (datetime): [optional]  # noqa: E501
            currency_code (str): Use either currency_id or currency_code. [optional]  # noqa: E501
            currency_decimal_places (int): [optional]  # noqa: E501
            currency_id (str): Use either currency_id or currency_code. [optional]  # noqa: E501
            currency_symbol (str): [optional]  # noqa: E501
            end_date (datetime): The date after which this bill is no longer valid or applicable. [optional]  # noqa: E501
            extension_date (datetime): The date before which the bill must be renewed (or cancelled). [optional]  # noqa: E501
            next_expected_match (datetime, none_type): When the bill is expected to be due.. [optional]  # noqa: E501
            next_expected_match_diff (str, none_type): Formatted (locally) when the bill is due.. [optional]  # noqa: E501
            notes (str, none_type): [optional]  # noqa: E501
            object_group_id (str, none_type): The group ID of the group this object is part of. NULL if no group.. [optional]  # noqa: E501
            object_group_order (int, none_type): The order of the group. At least 1, for the highest sorting.. [optional]  # noqa: E501
            object_group_title (str, none_type): The name of the group. NULL if no group.. [optional]  # noqa: E501
            order (int): Order of the bill.. [optional]  # noqa: E501
            paid_dates ([BillPaidDates]): Array of past transactions when the bill was paid.. [optional]  # noqa: E501
            pay_dates ([datetime]): Array of future dates when the bill is expected to be paid. Autogenerated.. [optional]  # noqa: E501
            skip (int): How often the bill must be skipped. 1 means a bi-monthly bill.. [optional]  # noqa: E501
            updated_at (datetime): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.amount_max = amount_max
        self.amount_min = amount_min
        self.date = date
        self.name = name
        self.repeat_freq = repeat_freq
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, amount_max, amount_min, date, name, repeat_freq, *args, **kwargs):  # noqa: E501
        """Bill - a model defined in OpenAPI

        Args:
            amount_max (str):
            amount_min (str):
            date (datetime):
            name (str):
            repeat_freq (BillRepeatFrequency):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            active (bool): If the bill is active.. [optional]  # noqa: E501
            created_at (datetime): [optional]  # noqa: E501
            currency_code (str): Use either currency_id or currency_code. [optional]  # noqa: E501
            currency_decimal_places (int): [optional]  # noqa: E501
            currency_id (str): Use either currency_id or currency_code. [optional]  # noqa: E501
            currency_symbol (str): [optional]  # noqa: E501
            end_date (datetime): The date after which this bill is no longer valid or applicable. [optional]  # noqa: E501
            extension_date (datetime): The date before which the bill must be renewed (or cancelled). [optional]  # noqa: E501
            next_expected_match (datetime, none_type): When the bill is expected to be due.. [optional]  # noqa: E501
            next_expected_match_diff (str, none_type): Formatted (locally) when the bill is due.. [optional]  # noqa: E501
            notes (str, none_type): [optional]  # noqa: E501
            object_group_id (str, none_type): The group ID of the group this object is part of. NULL if no group.. [optional]  # noqa: E501
            object_group_order (int, none_type): The order of the group. At least 1, for the highest sorting.. [optional]  # noqa: E501
            object_group_title (str, none_type): The name of the group. NULL if no group.. [optional]  # noqa: E501
            order (int): Order of the bill.. [optional]  # noqa: E501
            paid_dates ([BillPaidDates]): Array of past transactions when the bill was paid.. [optional]  # noqa: E501
            pay_dates ([datetime]): Array of future dates when the bill is expected to be paid. Autogenerated.. [optional]  # noqa: E501
            skip (int): How often the bill must be skipped. 1 means a bi-monthly bill.. [optional]  # noqa: E501
            updated_at (datetime): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.amount_max = amount_max
        self.amount_min = amount_min
        self.date = date
        self.name = name
        self.repeat_freq = repeat_freq
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
